//#########################################################################
// File: commands.c
//
// Serial commands input
//
//#########################################################################
// Last change: 30.11.2007
//#########################################################################
// holger.klabunde@t-online.de
// http://home.t-online.de/home/holger.klabunde/homepage.htm
// Kingstener.de.vu
//#########################################################################
// Compiler: AVR-GCC 3.2
//#########################################################################
#include <string.h>
#include "commands.h"
#include "serial.h"
#include "dos.h"
#include "lcd.h"
#include "mydefs.h"
#include "printf.h"
#include "fat.h"
#include "kcfile.h"
#include "pport.h"

unsigned long atoul(char *s);
//void FillSectorBuffer(unsigned char *buf);

//########################################################
unsigned char WaitCommand(void)
//########################################################
{
 char c, s[2];
 char line[30];
 char lin[14];
 unsigned char pos;
 unsigned int i;
 size_t strcspn();
 s[1]=0;
 strcpy(line,"\0");

 do
  {
   c=getp();
   if(c!=0x0D && c!=0x08 && c!=0x01){ s[0]=c;strcat(line,s);}
   if(c==0x08 && strlen(line)>0) line[strlen(line)-1]=0; //DEL
   if(c==0x01 && strlen(line)>0) line[strlen(line)-1]=0; //DEL
   if(c==0x03) strcpy(line,"\0"); //Break
  }while(c!=0x0D);
 
 if(line[0]==0) return NOCOMM;
 if (echo) {
     ser_putc(0x0a);
	 ser_putc(0x0d);
	}
 if(strlen(line)==1) //short commands without parameters
  {
  	if(line[0]=='H') return HELP;
	if(line[0]=='?') return HELP;
  	if(line[0]=='I') return INFO;
 	if(line[0]=='Q'){printf("bye...\n"); ser_putc(0x03); return NOCOMM;}
	if(line[0]=='V'){printf("KC87/Z9001 SD/MMC OS V0.2\n(w)2008 by Kingstener\nthanks to A.Fitzenreiter & H.Klabunde\n");return NOCOMM;}
    if(line[0]=='D'){listdir();return NOCOMM;}
  }

 if(strlen(line)==2) //short commands without parameters
	{
	if(strcmp(line,"E0")==0) { echo=0; return NOCOMM; }
	if(strcmp(line,"E1")==0) { echo=1; puts("Echo on\n"); return NOCOMM; }
	if(strcmp(line,"WB")==0) { ser_putc(0x1b); //Special mode
								ser_putc(0x55); //run code
								ser_putc(0x00); 
								ser_putc(0x03); return NOCOMM; }
	}
  if(strncmp(line,"RN ",3)==0)//rename
	{
   	for(i=2;i<30;i++) {if (line[i]==',')pos=i;};	//position vom "," suchen
	strncpy(lin,&line[pos+1],12);					//Teil nach komma kopieren
	for(i=pos;i<30;i++)line[i]=0;					//oberen Teil lschen
	if (Rename(&line[3],lin)==F_OK){printf("ok");}else printf("can't do it");
	return NOCOMM;
    }
   if(strcmp(line,"EOR")==0){return EORAM;}	
   if(strncmp(line,"MD ",3)==0)//make dir
	{
     if (Mkdir(&line[3])==F_OK){printf("ok");}else printf("can't do it");
   	 return NOCOMM;
    }
   	if(strncmp(line,"RM ",3)==0)//remove
	{
	 printf("Remove Y/N?>");ser_putc(0x80);if(Command()== 'Y'){Remove(&line[3]);printf("\nok");};
	 return NOCOMM;
	}
  
	if(strncmp(line,"CD ",3)==0)//change directory
	{
     if (Chdir(&line[3])!=F_OK) {printf("Dir not found");}
	 return NOCOMM;
	}
	if(strncmp(line,"L ",2)==0) {KCload(&line[2]); return NOCOMM;} // KCPRGLOAD;
	if(strncmp(line,"S ",2)==0) {KCsave(&line[2]); return NOCOMM;} //KCPRGSAVE;
    if(strncmp(line,"M ",2)==0) {memo(&line[2]); return NOCOMM;}//Speicher anzeigen

 puts("ERROR");   

 return NOCOMM;
}


//########################################################
void HelpScreen(void)
//########################################################
{
 puts("\nCommand List:\n");
 puts("Q         return to OS\n");
 puts("H or ?    show this help\n");
 puts("V         show version info\n");
 puts("I         drive informations\n");
 puts("D         list current directory\n");
 puts("CD (name) change dir (name)\n");
 puts("MD (name) make dir (name)\n");
 puts("RM (name) remove (name)\n");
 puts("RN (name),(new name) rename (name)\n");
 puts("L (name)  load file (name)\n");
 puts("S AAAA EEEE SSSS (name)\n");
 puts("  save file (name) SSSS=FFFF no auto\n");
 ser_putc(EOT);
}

//########################################################
//Very small atol(). only for decimal numbers. no hex
unsigned long atoul(char *s)
//########################################################
{
 unsigned char c;
 unsigned long tmp;
 
 tmp=0;

 while((c=*s++))
  {
   if(c>='0' && c<='9')
    {
     tmp*=10;
     tmp+=c-'0';
    }
  }
 
 return tmp;
}
//########################################################
void listdir(void)// das DIR-Commando...
//########################################################
{
	unsigned char z;
	 if(Findfirst()!=0)
    {
        do
        {
            if(ffblk.ff_attr==ATTR_FILE)
            {
            printf("F  %s  ",&ffblk.ff_name);
			printf("% 8lu\n",ffblk.ff_fsize);
            }
            if(ffblk.ff_attr==ATTR_DIRECTORY)
            {
            printf("D  %s",&ffblk.ff_name);
			printf("<DIR>\n");
            }
			z++;if(z==16){ser_putc(0x80);if(Command()==0){z=0;};}
			
        }while (Findnext()!=0 && z<16);////next oder Abbruch
    }
}

//########################################################
 unsigned int EOR(void) //RAM-Ende KC erfragen
//########################################################
	{
	unsigned int i;
	ser_putc(0x1b); //Special mode
	ser_putc(0x56); //download code
	ser_putc(0x36); //start address
	ser_putc(0x00);
	ser_putc(0x02);   //lnge
	ser_putc(0x00);
	i= (getp()+((getp())<<8))-0x100;// -100hex fr das Programm(beschreibschutz)
	return (i);
	}
