//#########################################################################
// File: kcfile.c  /  KC Serial Compactflash Firmware 0.02
//
// Most stuff is taken from Holger Klabunde/Arne Fitzenreiter

//#########################################################################
// Last change: 30.11.2007
//#########################################################################
// edit by Kingstener
//#########################################################################
// Processor: ATMega32
//#########################################################################
// Compiler: WinAVR
//#########################################################################
#include <string.h>
#include "mydefs.h"
#include "printf.h"
#include "serial.h"
#include "lcd.h"
#include "dos.h"
#include "pport.h"
#include "commands.h"
//unsigned char bmode; //send sectors binary 0=off
unsigned char printfmode; //0-serial,1-lcd,2both
unsigned char echo; //echo back serial input 0=off
char line[130];     //Zeichenpuffer
//########################################################
unsigned long htoul(char *s)
//########################################################
{
 unsigned char c;
 unsigned long tmp;
 unsigned char i;
 tmp=0;
 for(i=0;i<4;i++)
  {
   c=*s++;
   if(c>='0' && c<='9')
    {
     tmp*=16;
	 tmp+=c-'0';
    }
   if(c>='A' && c<='F')
    {
     tmp*=16;
	 tmp+=10+c-'A';
    }
  }
 
 return tmp;
}

//########################################################
void KCsave(char *FileName)//speichert KC-File auf CF als KC-Tapefile
//########################################################
{
	unsigned int i; 
	unsigned char smode;
	unsigned int aadr;
	unsigned int eadr;
	unsigned int sadr;
	unsigned int l;
	unsigned char block;
	char nametmp[13];

	if (strlen(FileName)>15)
	{
	
		aadr=htoul(&FileName[0]);
		eadr=htoul(&FileName[5]);
		sadr=htoul(&FileName[10]);
	
	
		l=0;
		for (i=0;i<13;i++) nametmp[i]=' '; 
		for (i=0;i<13;i++) 
		{
			if (FileName[14+i]=='.') l=9; 
			else
			{
				nametmp[l]=FileName[14+i];
				l++;
			}
			if (l>12) i=20;
		}
		

		LCDCls();
		printfmode=2; //Both
		printf("Save %s ...",&FileName[15]);

		if(Fopen(&FileName[15],F_WRITE))
		{
		
			line[0]=0xC3;
			line[1]='K';
			line[2]='C';
			line[3]='-';
			line[4]='T';
			line[5]='A';
			line[6]='P';
			line[7]='E';
			line[8]=' ';
			line[9]='b';
			line[10]='y';
			line[11]=' ';
			line[12]='A';
			line[13]='F';
			line[14]='.';
			line[15]=' ';
		
			line[16]=0x0; 
			Fwrite(line,17); //Tapeheader + Blocknr
		
			for (i=0;i<130;i++) line[i]=0;
		
			if (sadr==0xffff) smode=2;else smode=3;
			for (i=0;i<12;i++) line[i-1]=nametmp[i];
		
			line[0x10]=smode;
			line[0x11]=aadr; line[0x12]=aadr>>8;
			line[0x13]=eadr; line[0x14]=eadr>>8;
		
			if (smode==3)
			{
				line[0x15]=sadr; line[0x16]=sadr>>8;
			}
			Fwrite(line,128); //Block 1
		
			l=eadr-aadr+1;
			ser_putc(0x1b); //Special mode
			//Delay1ms(1);
				
			ser_putc(0x56); //download code
			ser_putc(aadr); //start address
			ser_putc(aadr>>8);
			ser_putc((l));   //lnge
			ser_clrbuff();
			ser_putc((l)>>8);

			LCDPos(2,1);
			for (i=0;i<130;i++) line[i]=0;
			block=0; i=0;
			while (l>0)
			{
				i++;
				line[i]=getp();
				l--;
				if (i>127) 
				{
					block++;
					line[0]=block;
					printfmode=1; //LCD
					LCDPos(2,1);
					printf("Block:%02x",(unsigned char)line[0]);
					Fwrite(line,129); //Datenblock
					for (i=0;i<130;i++) line[i]=0;
					i=0;
			
				}
			}
			line[0]=0xFF;
			Fwrite(line,129); //Letzer Block
		
			printfmode=0; //ser
			printf("\ndone");
			Fclose();
		}
		else 
		{
			printfmode=0; //ser
			printf("Cannot open File!");
		}
	}	
	else
	{
		printfmode=0; //ser
		printf("Zu wenig Parameter!");
	}
}
//########################################################
void KCload(char *FileName)//ldt KC-Tapefile von SD in den KC
//########################################################
{
	unsigned char counter; //Bytezhler
	unsigned int i; 
	unsigned int aadr;
	unsigned int eadr;
	unsigned int sadr;
	unsigned char smode;
	unsigned int l;
 
 	if(Fopen(FileName,F_READ))
	{

		LCDCls();
		printfmode=2; //LCD+ser
		printf("Load %s ",FileName);
	    printfmode=0; //SER
		counter=Fread(line,16);  //header 
		counter=Fread(line,1);   //Blocknr
//vp: bessere Erkennung von Typ und Autostart:
//3 Zeichen lesen. wenn alle gleich in D3..D5/D7..D9 und blocknr=1 dann BASIC, sonst MC
//wenn MC und TYP = 'COM' dann Autostart
		if(line[0] ==0)			//Maschinenprogramme sollten mit Block 0 beginnen
		{
			counter=Fread(line,128);
			smode=line[0x10];
			if (smode>=2 && smode<=3)
			{		
				aadr=(line[0x11]&0xFF)+(line[0x12]<<8);
				eadr=(line[0x13]&0xFF)+(line[0x14]<<8);
				sadr=(line[0x15]&0xFF)+(line[0x16]<<8);
		  		if (echo) printf("%04x %04x %04x ...",aadr,eadr,sadr);
				if (eadr>=EOR()){printf("!>EOR!");eadr=aadr;smode=2;} //berschreibschutz
				l=eadr-aadr+1;
		 		ser_putc(0x1b); //Special mode
				ser_putc(0x54); //upload code
				ser_putc(aadr); //start address
				ser_putc(aadr>>8);
				ser_putc((l));   //lnge
				ser_putc((l)>>8);
				while((counter=Fread(line,129))) //1 block lesen 
				{
					printfmode=1; //LCD
					LCDPos(2,1);
					printf("Block:%02x",(unsigned char)line[0]);
					for(i=1; i<counter; i++)
					{
						if (l>=1) 
						{
							ser_putc(line[i]);
							l--;
						}	
					}
				}
				printfmode=0;
				if (eadr>aadr)printf("\ndone");
		  		if (smode==3)
				{
					ser_putc(0x1b); //Special mode
					ser_putc(0x55); //run code
					ser_putc(sadr); 
					ser_putc(sadr>>8);
				}
			}
			else
			{		
				printfmode=0; //serial
				if (echo) printf("- No KC-Binary"); else printf("\r\bBoot error!");
			} 
		}
		 
		if(line[0] ==1)				//BASIC-Programme sollten mit Block1 beginnen
		{
			counter=Fread(line,13);
			aadr=(0x0401);
			l=(line[0x0b]&0xFF)+(line[0x0c]<<8);
			eadr=aadr+l;
		    if (echo) printf("%04x %04x",aadr,eadr);
			if (echo)printf(" <BASIC>");
			if (eadr>=EOR()){printf("!>EOR!");eadr=aadr;smode=2;} //berschreibschutz
			l=l+1;
			    
			ser_putc(0x1b); //Special mode
			ser_putc(0x54); //upload code
			ser_putc(aadr); //start address
			ser_putc(aadr>>8);
			ser_putc((l));   //lnge
			ser_putc((l)>>8);
			counter=Fread(line,115); //rest block lesen 
			for(i=0; i<counter; i++)
			{
				if (l>=1) 
				{
					ser_putc(line[i]);
					l--;
				}	
			}
			while((counter=Fread(line,129))) //1 block lesen 
				{
					printfmode=1; //LCD
					LCDPos(2,1);
					printf("Block:%02x",(unsigned char)line[0]);
					for(i=1; i<counter; i++)
					{
						if (l>=1) 
						{
							ser_putc(line[i]);
							l--;
						}	
					}
				}
		
			ser_putc(0x1b); //Special mode
			ser_putc(0x54); //upload code
			ser_putc(0xd7); //start address
			ser_putc(0x03);
			ser_putc(6);   //lnge
			ser_putc(0);
			for (i=0;i<3;i++)
			{
			ser_putc(eadr); //Endadresse eintragen, Variablen lschen
			ser_putc(eadr>>8);
			}
			printfmode=0;
			if (eadr>aadr)printf("\ndone");
		}
        
		 
	}
    else 
	{
		printfmode=0; //Serial
		if (echo) printf("File not found"); else printf("\r\bBootfile not exist!");
	}
	Fclose();
}
//########################################################
void memo(char *adr)  //gibt 8 zellen als hex aus /nutze hier "line" mit
//########################################################
  {
	unsigned int l;
	unsigned int aadr;
	aadr=htoul(&adr[0]);
	//l=htoul(&adr[5])+1;
	//if (l==0)l=0x09;
	ser_putc(0x1b); //Special mode
	ser_putc(0x56); //download code
	ser_putc(aadr); //start address
	ser_putc(aadr>>8);
	ser_putc(0x09);
	ser_putc(0x00);
	//ser_putc((l));   //lnge
	//ser_putc((l)>>8);
	for (l=1;l<10;l++) {line[l]=getp();}
	printf("%04x ",aadr);
	for (l=1;l<9;l++) {ser_puthex(line[l]);printf(" ");}
  }

//########################################################
void jump(char *adr)  //Programm starten
//########################################################
  {
	unsigned int l;
	unsigned int sadr;
	sadr=htoul(&adr[0]);


	//l=htoul(&adr[5])+1;
	//if (l==0)l=0x09;
	
	ser_putc(0x1b); //Special mode
	ser_putc(0x55); //run code
	ser_putc(sadr); 
	ser_putc(sadr>>8);
  }


