//#########################################################################
// File: kcscf.c  /  KC Serial Compactflash Firmware 
//
// Most stuff is taken from Holger Klabunde/Arne Fitzenreiter
//#########################################################################
// Last change: 30.11.2007
//#########################################################################
// edit by Kingstener
//#########################################################################
// Processor: ATMega32
//#########################################################################
// Compiler: WinAVR
//#########################################################################

#include <avr/io.h>
#include <avr/interrupt.h>
//#include <avr/signal.h>
//#include <stdarg.h>
//#include <string.h>
//#include <stdlib.h>

#include "mydefs.h"
#include "printf.h"
#include "serial.h"
#include "lcd.h"
#include "dos.h"
#include "commands.h"
#include "tape.h"
#include "kcfile.h"
#include "fat.h"
unsigned char bmode; //send sectors binary 0=off
unsigned char printfmode; //0-serial,1-lcd,2both
unsigned char echo; //echo back serial input 0=off
typedef struct
	{
	
	unsigned long dev_id;
	unsigned short app_version;
	unsigned short crc;
	
	} bootldrinfo_t;
//Kennung fr den Bootloader bei0x77f8  dev_id="x8CK" , Version  crc (mit crcgen auffllen)
const bootldrinfo_t bootlodrinfo __attribute__ ((section (".bootloader"))) = {0x7838434B, 0x0910, 0x0000};





//###################################################################################
//* Hauptprogramm */ vor Umstellung CF<--> SD/MMC dosdefs.h anpassen!!!
//###################################################################################
int main(void)
{
	unsigned char c;

	DDRC=0xFF;  	// set io-pins on PortC
	PORTC=0; 	//LCD-Datenbus

	DDRD=0xF6;  	// set io-pins on PortD
	PORTD=0x8A; 	//LCD-Steuersignale siehe lcd.h

	DDRA=0xc0; 	//Alles Eingnge, 6+7 ausg
	PORTA=0xFF; 	//Eingnge mit Pullups setzen

	DDRB=0xBD; 	//Alles Ausgnge ausser pb6,pb1
	PORTB=0xFF; 	

	SFIOR&=!(1<<PUD); 	//Pullups Enable

	sei();              //enable interrupts
	
	LCDInit();

	printfmode=1;  //LCD only
	LCDCls();
	printf("PIO<->SD 0.2");
	LCDPos(2,1);
	MMC_IO_Init();					//Karte initialisieren
	if(GetDriveInformation()!=F_OK) // get drive parameters
	{
		GREEN_OFF();
		printf("keine SD-Karte ?");
		
		printfmode=0;  //Ser only
		printf("\r\bSD-Karte nicht erkannt!\n");
		while(1);
	}
	LCDCls();
	Upload(); //fr KC85/3 loader ber tape
	echo=1;
	for(;;) 
	{
		printfmode=0;
	  	printf("\nSD>"); //Prompt ausgeben
		ser_putc(0x80);//Umschaltkommando
		printfmode=1;  //LCD only
		LCDCls();
		printf("PIO<->SD 0.2");
		LCDPos(2,1);
		printf("Ready");
		printfmode=0; //serial
		c=WaitCommand();
		switch(c)
		{
			case HELP: HelpScreen(); break;
			case INFO: MMC_IO_Init(); GetDriveInformation(); 
			printf ("Disc Size %lu kb\n",drivesize());
			printf ("Free Place %lu kb\n",drivefree()); break;
			case EORAM: printf("RAM-Ende:%04x",EOR()); break;
		}
	}
}



