/*! \file rename.c \brief Rename-Function */
//###########################################################
///	\ingroup singlefat
///	\code #include "dos.h" \endcode
///	\par Uebersicht
//###########################################################
// rename a file  - first version added by beta-frank - 23.04.07
//
// Quick and dirty rename function.
//
// Benutzung auf eigene Gefahr !
//
// Use at your own risk !
//
// 10.08.2007 Added renaming directorys too.
//
//#########################################################################
// Compiler: avr-gcc 4.1.1
//#########################################################################
//@{
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "dos.h"

//dos.c
#ifdef DOS_WRITE
 #ifdef DOS_RENAME
 
//###########################################################
/*!\brief Rename a file/dir
 * \param		OldName	DOS 8.3 name of the file/dir 
 * \param		NewName	DOS 8.3 name of the file/dir 
 * \return 		F_OK if file/dir could be renamed, F_ERROR if not
 */
U8 Rename(char *OldName, char *NewName)
//###########################################################
{
   if(FileFlag!=0) return F_ERROR; // don't rename if a file is open
  
   if(FindName(NewName)==FULL_MATCH) return F_ERROR; // File already exists !
   // FAT does NOT like DOUBLE filenames !
   
   FileAttr=0xFF; // test if we really find a file or a directory

   if(FindName(OldName)==FULL_MATCH)  //To fill some usefull variables...
    {
     if(FileAttr != ATTR_FILE && FileAttr != ATTR_DIRECTORY) return F_ERROR; // this was not a file/dir !

     MakeDirEntryName(NewName); //Split into name and extension
     UpdateFileEntry();

     return F_OK; 
    }

 return F_ERROR; // OldName not found
}
 #endif
#endif

//@}
